chrome.declarativeNetRequest.setExtensionActionOptions({
  displayActionCountAsBadgeText: true
});

let ruleById =
  fetch("./rules.json")
    .then(response => response.json())
    .then(rules => new Map(rules.map(rule => [parseInt(rule.id, 10), rule])));

chrome.declarativeNetRequest.onRuleMatchedDebug.addListener(async details =>
{
  let rule = (await ruleById).get(details.rule.ruleId);
  console.log("onRuleMatchedDebug",
              "frameId:", details.request.frameId,
              "parentFrameId:", details.request.parentFrameId,
              "type:", rule.action.type,
              "initiator:", details.request.initiator,
              "url:", details.request.url);
});

chrome.webNavigation.onBeforeNavigate.addListener(details =>
{
  console.log("onBeforeNavigate",
              "frameId:", details.frameId,
              "parentFrameId:", details.parentFrameId,
              "url:", details.url);
});
